/*
 * Class created by lensfrex.
 */

package cn.wustlinghang.wusthelper.rpc.response;

public enum ResponseCode {
    SUCCESS(20000, "成功"),
    REQUEST_TOO_FAST(20001, "技能冷却中..."),
    INVALID_REQUEST(30000, "非法请求"),
    PARAM_WRONG(30001, "参数错误"),
    PERMISSION_DENIED(40000, "权限不足"),
    TOKEN_EXPIRED(40001, "token过期"),
    TOKEN_INVALID(40002, "token无效"),
    SERVER_INTERNAL_ERROR(50000, "服务器内部错误"),
    API_NOT_IMPLEMENT(0, "接口未实现"),

    STUDENT_ID_DOES_NOT_EXISTS(60001,"学生学号不存在"),
    USER_WAS_BANNED_PUBLISH(60201, "用户被禁止发布告示信息"),
    IMAGE_FORMAT_WORN(60202, "上传的图片格式有误"),
    NOTICE_WAS_INTERCEPT(60203, "消息被系统拦截发布"),

    USER_DOES_NOT_MATCH_PUBLISHER(60301, "请求用户与告示发表者不匹配"),

    REQUEST_FILE_DOES_NOT_EXIST(60701, "请求的文件不存在");

    private final int code;

    private final String message;

    ResponseCode(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }
}


enum Code {
    Success, Fail, Wron
}

class Singleton {
    private static Singleton instance;

    private Singleton() {
    }

    public static Singleton getInstance() {
        if (instance == null) {
            instance = new Singleton();
        }

        return instance;
    }
}