package cn.wustlinghang.wusthelper.internal.graduate.api.http;

import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.wusthelper.internal.graduate.services.ScoreService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/score")
@ApplicationScoped
public class ScoreApi {
    private final ScoreService service;

    public ScoreApi(ScoreService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<Score> get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return this.parse(this.agent(cookie));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return service.getScore(cookie);
    }

    @POST
    @Path("/parse")
    public List<Score> parse(String html) throws RpcException {
        return service.parseScore(html);
    }
}
