package cn.wustlinghang.wusthelper.internal.graduate.api.http;

import cn.wustlinghang.mywust.data.global.StudentInfo;
import cn.wustlinghang.wusthelper.internal.graduate.services.StudentInfoService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

@Path("/student_info")
@ApplicationScoped
public class StudentInfoApi {
    private final StudentInfoService service;

    public StudentInfoApi(StudentInfoService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public StudentInfo get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return this.parse(this.agent(cookie));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return service.getStudentInfoPage(cookie);
    }

    @POST
    @Path("/parse")
    public StudentInfo parse(String html) throws RpcException {
        return service.parseStudentInfo(html);
    }
}
