package cn.wustlinghang.wusthelper.internal.graduate.bean;

import cn.wustlinghang.mywust.core.request.service.auth.GraduateLogin;
import cn.wustlinghang.mywust.core.request.service.captcha.solver.DdddOcrCaptchaSolver;
import cn.wustlinghang.mywust.core.request.service.graduate.GraduateCourseTableApiService;
import cn.wustlinghang.mywust.core.request.service.graduate.GraduateScoreApiService;
import cn.wustlinghang.mywust.core.request.service.graduate.GraduateStudentInfoApiService;
import cn.wustlinghang.mywust.core.request.service.graduate.GraduateTrainingPlanApiService;
import cn.wustlinghang.mywust.network.RequestClientOption;
import cn.wustlinghang.mywust.network.Requester;
import cn.wustlinghang.mywust.network.okhttp.SimpleOkhttpRequester;
import jakarta.inject.Singleton;
import org.eclipse.microprofile.config.inject.ConfigProperty;

public class MywustRequestAgentBeans {

    @Singleton
    public Requester requester() {
//            RequestClientOption option = new RequestClientOption();
//            RequestClientOption.Proxy proxy = RequestClientOption.Proxy.builder()
//                    .address("127.0.0.1")
//                    .port(8080)
//                    .build();
//            option.setProxy(proxy);
//
//            return new SimpleOkhttpRequester(option, true);

        return new SimpleOkhttpRequester(new RequestClientOption(), true);
    }

    @Singleton
    public RequestClientOption requestClientOption() {
        return new RequestClientOption();
    }

    @Singleton
    public GraduateLogin graduateLogin(
            @ConfigProperty(name = "ocr.service.provider", defaultValue = "http://localhost:12800")
            String ocrProvider,
            Requester requester) {
        return new GraduateLogin(requester, new DdddOcrCaptchaSolver(ocrProvider, requester));
    }

    @Singleton
    public GraduateCourseTableApiService graduateCourseTableApiService(Requester requester) {
        return new GraduateCourseTableApiService(requester);
    }

    @Singleton
    public GraduateScoreApiService graduateScoreApiService(Requester requester) {
        return new GraduateScoreApiService(requester);
    }

    @Singleton
    public GraduateStudentInfoApiService graduateStudentInfoApiService(Requester requester) {
        return new GraduateStudentInfoApiService(requester);
    }

    @Singleton
    public GraduateTrainingPlanApiService graduateTrainingPlanApiService(Requester requester) {
        return new GraduateTrainingPlanApiService(requester);
    }
}