package cn.wustlinghang.wusthelper.internal.library.api.http;

import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.wusthelper.internal.library.services.BookCoverImageUrlService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/cover_image")
@ApplicationScoped
public class BookCoverImageApi {
    private final BookCoverImageUrlService service;

    public BookCoverImageApi(BookCoverImageUrlService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<Score> get(@QueryParam("isbn") @NotNull String isbn)
            throws RpcException {
        return this.parse(this.agent(isbn));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("isbn") @NotNull String isbn)
            throws RpcException {
        return service.getBookCoverImageUrl(isbn);
    }

    @POST
    @Path("/parse")
    public List<Score> parse(String html) throws RpcException {
//        return parseService.parseScore(html);
        return null;
    }
}
