package cn.wustlinghang.wusthelper.internal.library.api.http;

import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.wusthelper.internal.library.services.BookDetailService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/book_detail")
@ApplicationScoped
public class BookDetailApi {
    private final BookDetailService service;

    public BookDetailApi(BookDetailService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<Score> get(@QueryParam("id") @NotNull String id)
            throws RpcException {
        return this.parse(this.agent(id));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("id") @NotNull String id)
            throws RpcException {
        return service.getBookDetail(id);
    }

    @POST
    @Path("/parse")
    public List<Score> parse(String html) throws RpcException {
//        return parseService.parseScore(html);
        return null;
    }
}
