package cn.wustlinghang.wusthelper.internal.library.api.http;

import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.wusthelper.internal.library.services.CurrentLoanService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/current_loan")
@ApplicationScoped
public class CurrentLoanApi {
    private final CurrentLoanService service;

    public CurrentLoanApi(CurrentLoanService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<Score> get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return this.parse(this.agent(cookie));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return service.getCurrentLoan(cookie);
    }

    @POST
    @Path("/parse")
    public List<Score> parse(String html) throws RpcException {
//        return parseService.parseScore(html);
        return null;
    }
}
