package cn.wustlinghang.wusthelper.internal.library.api.http;

import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.wusthelper.internal.library.services.SearchService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/search")
@ApplicationScoped
public class SearchApi {
    private final SearchService service;

    public SearchApi(SearchService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<Score> get(@QueryParam("keyword") @NotNull String keyword,
                           @QueryParam("page") @NotNull int page,
                           @QueryParam("page_size") @NotNull int pageSize)
            throws RpcException {
        return this.parse(this.agent(keyword, page, pageSize));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("keyword") @NotNull String keyword,
                        @QueryParam("page") @NotNull int page,
                        @QueryParam("page_size") @NotNull int pageSize)
            throws RpcException {
        return service.search(keyword, page, pageSize);
    }

    @POST
    @Path("/parse")
    public List<Score> parse(String html) throws RpcException {
//        return parseService.parseScore(html);
        return null;
    }
}
