package cn.wustlinghang.wusthelper.internal.library.services;

import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.wusthelper.internal.library.exception.LibraryRpcException;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public abstract class BaseService {
    protected LibraryRpcException wrapApiException(ApiException e, LibraryRpcException.SubModuleCode subModuleCode) {
        return switch (e.getCode()) {
            case NETWORK_EXCEPTION -> new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    subModuleCode,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
            case COOKIE_INVALID -> new LibraryRpcException(
                    LibraryRpcException.TypeCode.AUTH_EXCEPTION,
                    subModuleCode,
                    LibraryRpcException.ErrorCode.COOKIE_INVALID
            );
            default -> {
                log.error("图书馆：{}代理请求异常，异常未处理", subModuleCode.name());
                log.error("异常：", e);
                yield new LibraryRpcException(
                        LibraryRpcException.TypeCode.AUTH_EXCEPTION,
                        subModuleCode,
                        LibraryRpcException.ErrorCode.COOKIE_INVALID
                );
            }
        };
    }
}
