package cn.wustlinghang.wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.BookCoverImageUrlApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.wusthelper.internal.library.exception.LibraryRpcException;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class BookCoverImageUrlService extends BaseService {
    private final BookCoverImageUrlApiService service;

    public BookCoverImageUrlService(BookCoverImageUrlApiService service) {
        this.service = service;
    }

    public String getBookCoverImageUrl(String isbn) throws RpcException {
        try {
            return service.getBookCoverImageUrl(isbn);
        } catch (ApiException e) {
            throw wrapApiException(e, LibraryRpcException.SubModuleCode.PUBLIC_API);
        } catch (IOException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    LibraryRpcException.SubModuleCode.PUBLIC_API,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
        }
    }

}
