package cn.wustlinghang.wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.BookDetailApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.wusthelper.internal.library.exception.LibraryRpcException;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class BookDetailService extends BaseService {
    private final BookDetailApiService service;

    public BookDetailService(BookDetailApiService service) {
        this.service = service;
    }

    public String getBookDetail(String bookId) throws RpcException {
        try {
            return service.getBookDetail(bookId);
        } catch (ApiException e) {
            throw wrapApiException(e, LibraryRpcException.SubModuleCode.PUBLIC_API);
        } catch (IOException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    LibraryRpcException.SubModuleCode.PUBLIC_API,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
        }
    }

}
