package cn.wustlinghang.wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.CurrentLoanApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.wusthelper.internal.library.exception.LibraryRpcException;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class CurrentLoanService extends BaseService {
    private final CurrentLoanApiService service;

    public CurrentLoanService(CurrentLoanApiService service) {
        this.service = service;
    }

    public String getCurrentLoan(String cookie) throws RpcException {
        try {
            return service.getCurrentLoan(cookie);
        } catch (ApiException e) {
            throw wrapApiException(e, LibraryRpcException.SubModuleCode.PERSONAL_API);
        } catch (IOException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    LibraryRpcException.SubModuleCode.PERSONAL_API,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
        }
    }
}
