package cn.wustlinghang.wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.LoanHistoryApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.wusthelper.internal.library.exception.LibraryRpcException;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class LoanHistoryService extends BaseService {
    private final LoanHistoryApiService service;

    public LoanHistoryService(LoanHistoryApiService service) {
        this.service = service;
    }

    public String getLoanHistory(String cookie) throws RpcException {
        try {
            return service.getLoanHistory(cookie);
        } catch (ApiException e) {
            throw wrapApiException(e, LibraryRpcException.SubModuleCode.PERSONAL_API);
        } catch (IOException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    LibraryRpcException.SubModuleCode.PERSONAL_API,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
        }
    }
}
