package cn.wustlinghang.wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.SearchApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.wusthelper.internal.library.exception.LibraryRpcException;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class SearchService extends BaseService {
    private final SearchApiService service;

    public SearchService(SearchApiService service) {
        this.service = service;
    }

    public String search(String keyword, int page, int pageSize) throws RpcException {
        try {
            return service.search(keyword, page, pageSize);
        } catch (ApiException e) {
            throw wrapApiException(e, LibraryRpcException.SubModuleCode.PUBLIC_API);
        } catch (IOException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    LibraryRpcException.SubModuleCode.PUBLIC_API,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
        }
    }
}