package cn.wustlinghang.wusthelper.internal.physics.services;

import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.wusthelper.internal.physics.exception.PhysicsRpcException;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public abstract class BaseService {
    protected PhysicsRpcException wrapApiException(ApiException e, PhysicsRpcException.SubModuleCode subModuleCode) {
        return switch (e.getCode()) {
            case NETWORK_EXCEPTION -> new PhysicsRpcException(
                    PhysicsRpcException.TypeCode.NETWORK_EXCEPTION,
                    subModuleCode,
                    PhysicsRpcException.ErrorCode.NETWORK_ERROR
            );
            case COOKIE_INVALID -> new PhysicsRpcException(
                    PhysicsRpcException.TypeCode.AUTH_EXCEPTION,
                    subModuleCode,
                    PhysicsRpcException.ErrorCode.COOKIE_INVALID
            );
            default -> {
                log.error("物理实验：{}代理请求异常，异常未处理", subModuleCode.name());
                log.error("异常：", e);
                yield new PhysicsRpcException(
                        PhysicsRpcException.TypeCode.AUTH_EXCEPTION,
                        subModuleCode,
                        PhysicsRpcException.ErrorCode.COOKIE_INVALID
                );
            }
        };
    }
}
