package cn.wustlinghang.wusthelper.internal.undergrad.api.http;

import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradExamDelayApiService;
import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.wusthelper.internal.undergrad.services.ExamActivitiesService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/exam_activities")
@ApplicationScoped
public class ExamActivitiesApi {
    private final ExamActivitiesService service;

    public ExamActivitiesApi(ExamActivitiesService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public UndergradExamDelayApiService.ExamActivity[] get(
            @QueryParam("cookie") @NotNull String cookie,
            @QueryParam("term") @NotNull String term)
            throws RpcException {
        return this.agent(cookie, term);
    }

    @GET
    @Path("/agent")
    public UndergradExamDelayApiService.ExamActivity[] agent(
            @QueryParam("cookie") @NotNull String cookie,
            @QueryParam("term") @NotNull String term)
            throws RpcException {
        return service.getExamActivities(cookie, term);
    }

    @POST
    @Path("/parse")
    public List<Score> parse() throws RpcException {
        throw RpcException.ApiNotImplement();
    }
}
